/* --COPYRIGHT--,BSD
 * Copyright (c) 2017, Texas Instruments Incorporated
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * *  Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * *  Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * *  Neither the name of Texas Instruments Incorporated nor the names of
 *    its contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * --/COPYRIGHT--*/

#ifndef DRV_ADC_H_
#define DRV_ADC_H_

void adc_init(void);
int adc_poll_vcc(void);

extern volatile int adc_results[4]; 		// A3 .. A0 data
extern volatile int adc_results_flag;		// new A3 .. A0 data available

#define ADC_VIN_CHN		0
#define ADC_VLED_CHN	1
#define ADC_VBOOST_CHN	2
#define ADC_IIN_CHN		3

#define ADC_MAX			1024
#define ADC_VCC_VREF	40
#define ADC_VCC_RES		((adc_vcc*ADC_VCC_VREF)/ADC_MAX)

#define ADC_REF			25UL
#define ADC_VIN_DIV		((240+10)/10)
#define ADC_VIN_RES		(int)((adc_results[0]*ADC_REF*ADC_VIN_DIV)/ADC_MAX)
#define ADC_VBUCK_DIV	((240+10)/10)
#define ADC_VBUCK_RES	(int)((adc_results[1]*ADC_REF*ADC_VBUCK_DIV)/ADC_MAX)
#define ADC_VBOOST_DIV	((240+10)/10)
#define ADC_VBOOST_RES	(int)((adc_results[2]*ADC_REF*ADC_VBOOST_DIV)/ADC_MAX)
#define ADC_IIN_DIV		67
#define ADC_IIN_RES		(int)((adc_results[3]*ADC_REF*ADC_IIN_DIV)/(ADC_MAX))

#endif /* DRV_ADC_H_ */
