/* --COPYRIGHT--,BSD
 * Copyright (c) 2017, Texas Instruments Incorporated
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * *  Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * *  Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * *  Neither the name of Texas Instruments Incorporated nor the names of
 *    its contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * --/COPYRIGHT--*/

#ifndef DRV_TIMER_H_
#define DRV_TIMER_H_

#include <stdbool.h>

enum error_enum{fail_none, fail_temp, fail_boost, fail_efuse};

extern unsigned int framerate;
extern unsigned char framerate_flag;
extern unsigned int flash_count;
extern unsigned volatile int flash_counter;
extern unsigned char flash_count_flag;
extern unsigned int ontime;
extern unsigned char ontime_flag;
extern unsigned int timebaserange;
extern unsigned char operation_state;
extern unsigned int running;
extern unsigned char trigger_src; // 0 = int, 1 = ext
extern enum error_enum error;
extern const char error_text[][6];
extern unsigned int flash_bracketing;
extern unsigned char flash_bracketing_flag;
extern unsigned char current_bracketing_flag;
extern int current_bracketing;
extern const char flash_bracketing_text[][5];
extern unsigned int flash_bracketing_counter;

void timer_init(void);
void timer_init_ext(void);
void timer_external(void);
void timer_d_configure(int on_time, unsigned int current, int range);
inline int timer_d_trigger(void);
extern __interrupt void ta0_isr(void);
void dc_mode(bool on);


#endif /* DRV_TIMER_H_ */
